/*
 *	$Id: lex_stuff.c,v 1.5 2000/08/22 15:12:01 haley Exp $
 */
/************************************************************************
*                                                                       *
* This file is free software; you can redistribute it and/or modify     *
* it under the terms of the GNU General Public License as published     *
* by the Free Software Foundation; either version 2 of the License, or  *
* (at your option) any later version.                                   *
*                                                                       *
* This software is distributed in the hope that it will be useful, but  *
* WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
* General Public License for more details.                              *
*                                                                       *
* You should have received a copy of the GNU General Public License     *
* along with this software; if not, write to the Free Software         *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307   *
* USA.                                                                  *
*                                                                       *
************************************************************************/

/***********************************************************************
*                                                                      *
*                          Copyright (C)  1990                         *
*            University Corporation for Atmospheric Research           *
*                          All Rights Reserved                         *
*                                                                      *
*                          NCAR View V3.01                             *
*                                                                      *
***********************************************************************/

/*
 *	lex_stuff.c
 *
 *	Routines so support lexical parser generated by lex
 */
# include <stdio.h>
extern FILE *yyout, *yyin;
extern int yyprevious , *yyfnd;
extern char yyextra[];
extern char yytext[];
extern int yyleng;

extern struct {
	int *yyaa, 
	*yybb; int 
	*yystops;
	} *yylstate [], **yylsp, **yyolsp;

yyreject ()
{
	for( ; yylsp < yyolsp; yylsp++)
		yytext[yyleng++] = yyinput();

	if (*yyfnd > 0)
		return(yyracc(*yyfnd++));

	while (yylsp-- > yylstate) {
		yyunput(yytext[yyleng-1]);
		yytext[--yyleng] = 0;
		if (*yylsp != 0 && (yyfnd= (*yylsp)->yystops) && *yyfnd > 0)
			return(yyracc(*yyfnd++));
	}

	if (yytext[0] == 0)
		return(0);

	yyoutput(yyprevious = yyinput());
	yyleng = 0;
	return(-1);
}

yyracc(yyfnd)
	int	yyfnd;
{
	yyolsp = yylsp;
	if (yyextra[yyfnd]) {

		while ((yyback((*yylsp)->yystops, -yyfnd) != 1) 
			&& yylsp > yylstate) {

			yylsp--;
			yyunput(yytext[--yyleng]);
		}
	}

	yyprevious = yytext[yyleng - 1];
	yytext[yyleng] = 0;
	return(yyfnd);
}

yywrap()
{
	return(1);
}
